using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection.Emit;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace FrameNotificationSink_Page
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        class Listener : IFrameNotificationSinkListener
        {
            public void SinkConnected(FrameType frameType)
            {
                // sinkɐڑƂ̏
            }


            public void SinkDisconnected()
            {
                // sinkɐڑƂ̏
            }
            public void FrameReceived(IFrame frame)
            {


            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // fBXvC̃TCY𒲐
            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveDisplaySize = icImagingControl1.Size;

            var listener = new Listener();
            var sink = new TIS.Imaging.FrameNotificationSink(listener);
            icImagingControl1.Sink = sink;

        }

        private void cmdSelectDevice_Click(object sender, EventArgs e)
        {
            if (icImagingControl1.LiveVideoRunning)
            {
                icImagingControl1.LiveStop();
            }
            // foCX_CAO\
            icImagingControl1.ShowDeviceSettingsDialog();

            icImagingControl1.LiveStart();
        }



        private void cmdShowOriginalDialog_Click(object sender, EventArgs e)
        {
            //@vpeB_CAO\
            icImagingControl1.ShowPropertyDialog();
        }
        private void cmdDisplayON_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStop();
            icImagingControl1.LiveDisplay = true;
            icImagingControl1.LiveStart();
        }

        private void cmdDisplayOFF_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStop();
            icImagingControl1.LiveDisplay = false;
            icImagingControl1.LiveStart();
        }

        private void cmdLiveStartFrameNotificationSink_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStart();
        }

        private void cmdLiveStopFrameNotificationSink_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStop();
        }

        //CtrlL[ƃ}EXzC[삵̏
        private int intZoom;
        private void icImagingControl1_MouseWheel(object sender, MouseEventArgs e)
        {

            //Ctrl L[ꂽԂł邩mF
            if ((Control.ModifierKeys & Keys.Control) == Keys.Control)
            {
                if (icImagingControl1.LiveDisplayDefault == false)
                {
                    int value = (e.Delta * SystemInformation.MouseWheelScrollLines / 360) + intZoom;


                    intZoom = value;
                    icImagingControl1.LiveDisplayZoomFactor = intZoom / 10.0f;



                }
            }

        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            this.icImagingControl1.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseWheel);
            intZoom = (int)(icImagingControl1.LiveDisplayZoomFactor * 10.0f);
        }
        private ulong _framerate =0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            //if (icImagingControl1.LiveVideoRunning)
            //{
            //    lbltext.Text = "fps Frame:x 擾" + "\r\n" +  "x/x/x/x@肱ڂ";
            //}
            //else
            //{
            //    lbltext.Text = "0fps Frame:x 擾" + "\r\n" + "x/x/x/x@肱ڂ";
            //}
            ulong currentframerate=0;
            
            if (icImagingControl1.DeviceValid)
            {
                //DirectShow/ICImagingControlɈnÕhCoɑoꂽt[
                ulong _framesDelivered = icImagingControl1.DriverFrameDropInformation.FramesDelivered;

                currentframerate = 1000*(_framesDelivered- _framerate)/ ulong.Parse(timer1.Interval.ToString());


                //AvP[VŃhbvt[BR[obNɃhCoAvP[Ṽobt@ւ̃Rs[Ɏ Ԃ鎖ȗvłB
                ulong _framesDroppedDueToApplicationQueue = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueToApplicationQueue;
                //f[^]rɃhbvt[BMf[^sSłAf[^ш敝\łȂƂƂ čl܂B
                ulong _framesDroppedDueToPacketLoss = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueToPacketLoss;
                //hCoŃhbvt[B擾tH[}bgo͂tH[}bgɉ摜ϊ̂ԂɂĂȂ Ƃl炦܂B
                ulong _framesDroppedDueToTransforms = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueToTransforms;
                //łȂhbvt[BhCot[hbv񋟂ĂȂl܂B
                ulong _framesDroppedDueUnspecified = icImagingControl1.DriverFrameDropInformation.FramesDroppedDueUnspecified;

                lbltext.Text = currentframerate.ToString() + "fps Frame:" + _framesDelivered.ToString() + "擾" + "\r\n"
                    + _framesDroppedDueToApplicationQueue.ToString() + "/"
                    + _framesDroppedDueToPacketLoss.ToString() + "/"
                    + _framesDroppedDueToTransforms.ToString() + "/"
                    + _framesDroppedDueUnspecified.ToString() + "@肱ڂ";

                _framerate = _framesDelivered;

            }


        }




    }



}